import math
import Conf
import random
from Box import Box
from StepBloc import StepBloc
from GroupCircle import GroupCircle
from Collection import Collection
'''
Created on 24 mars 2019

@author: invite
'''

class BaseWay(object):
    '''
    classdocs
    '''


    def __init__(self, base):
        '''
        Constructor
        '''
        self.base=base
        random.seed()
        self.c=[]
        
        for o in StepBloc(base).getList():
            self.c.append(o)
        
        pxb=self.base.getPx()
        pyb=self.base.getPy()
        
        rand=random.random()
        rand=0.3
        if rand < 0.4:
            #***
            # circle
            #***
            
            if self.base.getSx()>self.base.getSy():
                rayon=self.base.getSx()*2
            else:
                rayon=self.base.getSy()*2
            
            rayon+=random.randint(0,Conf.stepLong)
                
            nbMax=((2*math.pi*rayon)/(math.sqrt(2)* \
                (Conf.circleSizeXmax+Conf.circleSizeYmax-Conf.circleSizeXmin-Conf.circleSizeYmin)/2))-2
            if nbMax>8:
                nb=random.randint(8,int(nbMax))
            else:
                nb=8
            
            sizeX=random.randint(Conf.circleSizeXmin,Conf.circleSizeXmax)
            sizeY=random.randint(Conf.circleSizeYmin,Conf.circleSizeYmax)
            z=self.base.getPz()+self.base.getSz()
            
            if random.random() < Conf.ratioTailleFixe:
                sizeZ=random.randint(z-Conf.stepHight,z)
                c=Collection(nb=nb,type="box",sizeX=sizeX,sizeY=sizeY,sizeZ=sizeZ)
            else:
                c=Collection(nb=nb,type="box", \
                         sizeXmin=Conf.circleSizeXmin,sizeYmin=Conf.circleSizeYmin,sizeZmin=Conf.circleSizeZmin, \
                         sizeXmax=sizeX,sizeYmax=sizeY,sizeZmax=z+Conf.stepHight)
                         
            self.c=GroupCircle(c,rayon=rayon,shX=self.base.getPx(),shY=self.base.getPy()).getList()
            nbWay=1
        
        elif rand >= 0.4 :
            nbWay=random.randint(Conf.baseWayMin,Conf.baseWayMax)
            
        # gateways
        for i in range(1,nbWay+1):
            sx=random.randint(Conf.baseWaySxMin,Conf.baseWaySxMax)
            sy=random.randint(Conf.baseWaySyMin,Conf.baseWaySyMax)
            
            
            #baseBorder=math.sqrt((self.base.getSx()**2)+(self.base.getSy()**2))
            baseBorder=(self.base.getSx()+self.base.getSy())/2
            #baseBorder=0
            rad=random.uniform(0,2*math.pi)
            
            
            px,py=self.getNextHop(pxb,pyb,sy+baseBorder,rad)
            
            b=Box(sx=sx,sy=sy,sz=Conf.baseWaySz,px=px,py=py,pz=self.base.getPz(), \
                              type="box",rotation=rad*(180/math.pi),c=self.c)
            self.c.append(b)
            
            if self.base.getPz()+self.base.getSx() > Conf.stepHight:
                for o in StepBloc(b).getList():
                    self.c.append(o)
        
  
        
        
            

    def getNextHop(self,pxb,pyb,sy,rad):
        
        if rad>=0 or rad<(math.pi/2):
            px=pxb+(math.sin(rad)*sy)
            py=pyb-(math.cos(rad)*sy)
        elif rad>=(math.pi/2) or rad<math.pi:
            px=pxb-(math.cos(rad-(math.pi/2))*sy)
            py=pyb-(math.sin(rad-(math.pi/2))*sy)            
        elif rad>=math.pi or rad<(3*math.pi)/2:
            px=pxb-(math.sin(math.pi-rad)*sy)
            py=pyb+(math.cos(math.pi-rad)*sy)
        elif rad>=(3*math.pi)/2 or rad<=2*math.pi:
            px=pxb+(math.sin((2*math.pi)-rad)*sy)
            py=pyb+(math.cos((2*math.pi)-rad)*sy)
        
        return px,py
    

    
    def getList(self):
        return self.c
            