'''
Created on 4 nov. 2018

@author: invite
'''
import random
from Box import Box
import Conf

class Collection(object):
    '''
    classdocs
    '''


    def __init__(self,** keys):
        
        self.surface=0
        self.c=[]
        self.sx=0
        self.sy=0
        self.sz=0
        
        self.sizeXmax=20
        self.sizeYmax=20
        self.sizeZmax=30
        
        self.sizeXmin=1
        self.sizeYmin=1
        self.sizeZmin=3
        self.name="unknown"
        
        self.protected=False
        self.rotation=0
        self.square=False
        

        self.type="box"
        

        if 'nb' in keys :
            self.n=keys['nb']  
        if 'protected' in keys :
            self.protected=keys['protected'] 
        if 'square' in keys :
            self.square=keys['square']
        if 'name' in keys :
            self.name=keys['name']
        
        if 'sizeX' in keys :
            self.sx=keys['sizeX']
        if 'sizeY' in keys :
            self.sy=keys['sizeY']
        if 'sizeZ' in keys :
            self.sz=keys['sizeZ']
        
        
        if 'sizeXmin' in keys :
            self.sizeXmin=keys['sizeXmin']
        if 'sizeYmin' in keys :
            self.sizeYmin=keys['sizeYmin']
        if 'sizeZmin' in keys :
            self.sizeZmin=keys['sizeZmin']
            
        if 'sizeXmax' in keys :
            self.sizeXmax=keys['sizeXmax']
        if 'sizeYmax' in keys :
            self.sizeYmax=keys['sizeYmax']
        if 'sizeZmax' in keys :
            self.sizeZmax=keys['sizeZmax']
        if 'type' in keys:
            if keys['type']=="box":
                self.type="box"
            elif keys['type']=="pyramid":
                self.type="pyramid"
            else:
                self.type="random"
                
        if 'rotation' in keys :
            self.rotation=keys['rotation']
 
            
        if self.n!=0: 
            self.genCollection(self.type)
                
        
                
    
    def add(self,o):
        self.surface=self.surface+(o.getSx()*o.getSy())
        self.c.append(o)
        
    #def draw(self):
    #    print("# collection :"+self.name+" - n blocs :"+str(len(self.getList())))
    #    for o in self.c:
    #        o.draw()
    
    def len(self):
        return len(self.c)
    
    def getC(self):
        return self.c
    
    def getName(self):
        return self.name
    
    def getList(self):
        return self.c
    
    def getSurface(self):
        return self.surface   
        
    def genCollection(self,type):
                
        random.seed()
        
        #************************
        # taille des blocs fixe
        #************************
        if self.sx!=0 and self.sy!=0 and self.sz!=0:
            for i in range(self.n):

                    
                px=random.randint(0,2*Conf.worldSize)
                py=random.randint(0,2*Conf.worldSize)
                pz=0
                
                if self.type == "random":
                    if random.random() > Conf.ratioPyramid:
                        t="box"
                    else:
                        t="pyramid"
                    
                else:
                    t=type
                        
                
                b=Box(sx=self.sx,sy=self.sy,sz=self.sz,px=px,py=py,pz=pz,type=t,rotation=self.rotation,c=self.c)
                
                if self.protected:
                    b.setProtected(True)
                    
                self.add(b)   
                

                    
                
        #************************
        # taille des blocs aleatoire
        #************************    
        elif self.sizeXmin!=None and self.sizeYmin!=None and self.sizeZmin!=None and self.sizeXmax!=None and self.sizeYmax!=None and self.sizeZmax!=None:
                    
            for i in range(self.n):
                
                sx=random.uniform(self.sizeXmin,self.sizeXmax)
                sy=random.uniform(self.sizeYmin,self.sizeYmax)
                        
                #on evite les rectrangles trop long, pour eviter les trou a drapeau
                if self.square is True :
                    if sy > 2*sx:
                        sy=2*sx
                
                sz=random.uniform(self.sizeZmin,self.sizeZmax)
                    
                px=random.randint(0,2*Conf.worldSize)
                py=random.randint(0,2*Conf.worldSize)
                pz=0
                
                if self.type == "random":
                    if random.random() > Conf.ratioPyramid:
                        t="box"
                    else:
                        t="pyramid"
                else:
                    t=type
                
                b=Box(sx=sx,sy=sy,sz=sz,px=px,py=py,pz=pz,type=t,rotation=self.rotation,c=self.c)
                
                if self.protected:
                    b.setProtected(True)
                    
                self.add(b)

        else:
            print("wrong collection parameter")
            exit()    


            
    def setSizeXmax(self,x):
        self.sizeXmax=x
        
    def setSizeYmax(self,y):
        self.sizeYmax=y
        
    def setSizeZmax(self,z):
        self.sizeZmax=z
        
    
    
